<?php  

class paspayment2 extends PaymentModule{  

	private $_html = '';
	private $_postErrors = array();

	public function __construct(){  

		$this->name = 'paspayment2';  
		$this->tab = 'payments_gateways';  
		$this->version = '1.0';  
		$this->author = 'www.softiran.org';
		
		$this->currencies = true;
  		$this->currencies_mode = 'radio';
		
		parent::__construct();  		
		
		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('درگاه پرداخت الکترونیک سپهر');  
		$this->description = $this->l('ساخته شده توسط سافت ایران به سفارش مبنا کارت');  
		$this->confirmUninstall = $this->l('شما از حذف این ماژول مطمئن هستید ؟');

		if (!sizeof(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('ارز تنظیم نشده است');

		$config = Configuration::getMultiple(array('PAS2_TER', ''));			
		if (!isset($config['PAS2_TER']))
			$this->warning = $this->l('شما باید ترمینال درگاه را وارد کنید');
			
		if ($_SERVER['SERVER_NAME'] == 'localhost')
			$this->warning = $this->l('این ماژول روی لوکال کار نمیکند');


	}  
	public function install(){
		if (!parent::install()
	    	OR !Configuration::updateValue('PAS2_HASHKEY', '')
	    	OR !Configuration::updateValue('PAS2_TER', '')
	      	OR !$this->registerHook('payment')
	      	OR !$this->registerHook('paymentReturn')){
			    return false;
		}else{
		    return true;
		}
	}
	public function uninstall(){
		if ( !Configuration::deleteByName('PAS2_HASHKEY') 
			OR !Configuration::deleteByName('PAS2_TER') 
			OR !parent::uninstall())
			return false;
		return true;
	}
	
	public function displayFormSettings()
	{
		$bank_id = Configuration::get('PAS2_HASHKEY');
		
		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="../img/admin/cog.gif" alt="" class="middle" />'.$this->l('Settings').'</legend>
				<label>'.$this->l('ترمینال درگاه').'</label>
				<div class="margin-form"><input type="text" size="30" name="PAS2_TER" value="'.Configuration::get('PAS2_TER').'" /></div>
				
				<p class="hint clear" style="display: block; width: 501px;"><a href="http://www.softiran.org" target="_blank" >'.$this->l('ساخته شده توسط گروه برنامه نویسی سافت ایران').'</a></p></div>
				<center><input type="submit" name="submitPAS2" value="'.$this->l('به روز رسانی تنظیمات').'" class="button" /></center>			
			</fieldset>
		</form>';
	}

	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Settings updated').'
		</div>';
	}
	
	public function displayErrors()
	{
		foreach ($this->_postErrors AS $err)
		$this->_html .= '<div class="alert error">'. $err .'</div>';
	}

       	public function getContent()
	{
		$this->_html = '<h2>'.$this->l('paspayment2').'</h2>';
		if (isset($_POST['submitPAS2']))
		{
			if (empty($_POST['PAS2_TER']))
				$this->_postErrors[] = $this->l('ترمینال را وارد کنید');
			if (empty($_POST['HashKey']))
				 $_POST['HashKey'] = '0';
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('PAS2_HASHKEY', $_POST['HashKey']);
				Configuration::updateValue('PAS2_TER', $_POST['PAS2_TER']);
				$this->displayConf();
			}
			else
				$this->displayErrors();
		}

		$this->displayFormSettings();
		return $this->_html;
	}

	private function displayIrankishPayment()
	{
		$this->_html .= '<img src="../modules/paspayment2/paspayment2.png" style="float:left; margin-right:15px;"><b>'.$this->l('این ماژول امکان واریز آنلاین توسط درگاه پرداخت الکترونیک سپهر را مهیا می سازد').'</b><br /><br />
		'.$this->l('تمامی کارت های عضو شتاب').'<br /><br /><br />';

	}

	public function execPayment($cart)
	{
		global $cookie, $smarty;
	
		$purchase_currency = new Currency(Currency::getIdByIsoCode('IRR'));			
		$OrderDesc = Configuration::get('PS_SHOP_NAME'). $this->l(' Order');
		$current_currency = new Currency($this->context->cookie->id_currency);
		if($current_currency->id == $purchase_currency->id)
			$PurchaseAmount= number_format($cart->getOrderTotal(true, 3), 0, '', '');		 
		else
			$PurchaseAmount= number_format(Tools::convertPrice($cart->getOrderTotal(true, 3), $purchase_currency), 0, '', '');	 
		
		$terminal = trim(Configuration::get('PAS2_TER'));			
		$OrderId = $cart->id;
		
		$amount = trim($PurchaseAmount);
		$redirectAddress = $this->context->link->getModuleLink($this->name, 'validation', array(), true);
		$redirectAddress = $redirectAddress.'?paid='.$OrderId;
		$invoiceNumber = time();

		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				echo '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir:8080" method="POST">
					<input type="hidden" id="TerminalID" name="TerminalID" value="'.$terminal.'">
					<input type="hidden" id="token" name="token" value="'.$res['Accesstoken'].'">
					</form><script>
					function submitpas() {
					document.getElementById("paymentUTLfrm").submit();
					}
					window.onload=submitpas; </script>';die;
			}else
			{
				echo ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				die;
			}
		}
		else
		{
			echo ('پورت 8081 در هاست شما بسته است !');
			die;
		}

	}
	public function confirmPayment($order_amount,$Status,$Refnumber)
	{
		
	}
		
	public function showMessages($result)
	{                

	}	
		public function error($str) {
		return '<div class="alert alert-danger" style="text-align: center;font-family: Tahoma;"> ' . $str . '</div>';
	}
	public function hookPayment($params){

		if (!$this->active)
			return ;
		
		return $this->display(__FILE__, 'payment.tpl');
	}
	
	public function hookPaymentReturn($params)
	{
		if (!$this->active)
		       return ;

		return $this->display(__FILE__, 'confirmation.tpl');
	}

}